#ifndef _SYS_CLIENT_H_
#define _SYS_CLIENT_H_

#include "pktIO.h"

struct reflex;

/*------------------------------------------------------------*/
/*                     public interface                       */
/*------------------------------------------------------------*/

#ifdef __cplusplus
extern "C"
{
#endif

  struct reflexSystem {
    int port;
    
    int (*lcdDumpRpl) (struct reflex *reflex, int rv, unsigned char id,
		       int ts,
		       unsigned char row,
		       unsigned char nbytes, unsigned char *data);
    
    int (*statusRpl)  (struct reflex *reflex, int rv, unsigned char id,
		       int ts,
		       int volts, unsigned char brake);
    
    int (*unknownRpl) (struct reflex *reflex, unsigned char id,
		       unsigned char size,
		       unsigned char *buffer, unsigned char opcode);
    
    /* ---------------------------------------- */

    int (*lcdDumpReq) (struct reflex *reflex, unsigned char id);
    
    int (*statusReq)  (struct reflex *reflex, unsigned char id);
    
    /* ---------------------------------------- */

    int (*handlePort) (struct reflex *reflex, int size, unsigned char *buffer,
		       unsigned char id, unsigned char opcode);
    
    int (*destroy)    (struct reflexSystem *ptr);
  };

  struct reflexSystem *reflexSystemNew (int port);
#ifdef __cplusplus
}
#endif

/*============================================================*/

#if 0
#define SYS_LCD_DUMP            0
#define SYS_STATUS              1
#endif

#endif
